package javax.imageio.spi;

import javax.imageio.ImageReader;
import java.io.IOException;
import javax.imageio.stream.ImageInputStream;

public abstract class ImageReaderSpi extends ImageReaderWriterSpi
{
    @Deprecated
    public static final Class[] STANDARD_INPUT_TYPE;
    protected Class[] inputTypes;
    protected String[] writerSpiNames;
    private Class readerClass;
    
    protected ImageReaderSpi() {
        this.inputTypes = null;
        this.writerSpiNames = null;
        this.readerClass = null;
    }
    
    public ImageReaderSpi(String s, String s2, String[] array, String[] array2, String[] array3, String s3, Class[] array4, String[] array5, boolean b, String s4, String s5, String[] array6, String[] array7, boolean b2, String s6, String s7, String[] array8, String[] array9) {
        super(s, s2, array, array2, array3, s3, b, s4, s5, array6, array7, b2, s6, s7, array8, array9);
        this.inputTypes = null;
        this.writerSpiNames = null;
        this.readerClass = null;
        if (array4 == null) {
            throw new IllegalArgumentException("inputTypes == null!");
        }
        if (array4.length == 0) {
            throw new IllegalArgumentException("inputTypes.length == 0!");
        }
        this.inputTypes = ((array4 == ImageReaderSpi.STANDARD_INPUT_TYPE) ? new Class[] { ImageInputStream.class } : ((Class[])array4.clone()));
        if (array5 != null && array5.length > 0) {
            this.writerSpiNames = (String[])(String[])array5.clone();
        }
        return;
    }
    
    public Class[] getInputTypes() {
        return (Class[])(Class[])this.inputTypes.clone();
    }
    
    public abstract boolean canDecodeInput(Object p0) throws IOException;
    
    public ImageReader createReaderInstance() throws IOException {
        return this.createReaderInstance(null);
    }
    
    public abstract ImageReader createReaderInstance(Object p0) throws IOException;
    
    public boolean isOwnReader(ImageReader imageReader) {
        if (imageReader == null) {
            throw new IllegalArgumentException("reader == null!");
        }
        return imageReader.getClass().getName().equals(this.pluginClassName);
    }
    
    public String[] getImageWriterSpiNames() {
        return (this.writerSpiNames == null) ? null : ((String[])(String[])this.writerSpiNames.clone());
    }
    
    static {
        STANDARD_INPUT_TYPE = new Class[] { ImageInputStream.class };
    }
}
